///////////////////////////////////////////////////////////////////////////////////
// Main : WASAPIĐTv v1.00                                               //
//                                                                               //
// ̃\[XR[h͎RɉςĎgp\łB                                //
// ܂pp\łAׂĂ̊Ő삷ۏ͂܂B      //
//                          http://www.charatsoft.com/                           //
///////////////////////////////////////////////////////////////////////////////////
#include "CWindow.h"
#include "CWav.h"

#define DEBUGMODE				// fobOo͂Ȃꍇ̓Rg
#include "DEBUG.H"

// }N
#define SAFE_RELEASE(x)		{ if( x ) { x->Release(); x=NULL; } }
#define SAFE_FREE(x)		{ if( x ) { free(x); x=NULL; } }


//////////////////////////////////////////////////////////////////////////////////////
// WASAPI֘A
//////////////////////////////////////////////////////////////////////////////////////

// wb_
#include <mmdeviceapi.h>
#include <Audioclient.h>
#include <audiopolicy.h>
#include <endpointvolume.h>
#include <FunctionDiscoveryKeys_devpkey.h>

// Cu
#pragma comment(lib, "Avrt.lib")
#pragma comment(lib, "winmm.lib")

// C^[tF[XGUID̎(vWFNgCt@CɕK1Kv)
const CLSID CLSID_MMDeviceEnumerator	= __uuidof(MMDeviceEnumerator);
const IID IID_IMMDeviceEnumerator		= __uuidof(IMMDeviceEnumerator);
const IID IID_IAudioClient				= __uuidof(IAudioClient);
const IID IID_IAudioClock				= __uuidof(IAudioClock);
const IID IID_IAudioRenderClient		= __uuidof(IAudioRenderClient);



//////////////////////////////////////////////////////////////////////////////////////
// O[oϐ
//////////////////////////////////////////////////////////////////////////////////////
CWindow					win;							// EBhE
CWav					wav;							// WAVt@C
int						iAddr = 0;						// WAVt@C̍Đʒu

IMMDeviceEnumerator		*pDeviceEnumerator	= NULL;		// }`fBAfoCX񋓃C^[tF[X
IMMDevice				*pDevice			= NULL;		// foCXC^[tF[X
IAudioClient			*pAudioClient		= NULL;		// I[fBINCAgC^[tF[X
IAudioRenderClient		*pRenderClient		= NULL;		// _[NCAgC^[tF[X
int						iFrameSize			= 0;		// 1Tṽobt@TCY

HANDLE					hEvent				= NULL;		// Cxgnh
HANDLE					hThread				= NULL;		// Xbhnh
BOOL					bThreadLoop			= FALSE;	// Xbh


//////////////////////////////////////////////////////////////////////////////////////
// ĐXbh
//////////////////////////////////////////////////////////////////////////////////////
DWORD CALLBACK PlayThread( LPVOID param )
{
	DEBUG( "XbhJn\n" );

	while( bThreadLoop ) {
		// ̃obt@擾KvɂȂ܂őҋ@
		DWORD retval = WaitForSingleObject( hEvent,2000 );
		if( retval!=WAIT_OBJECT_0 ) {
			DEBUG( "^CAEg\n" );
			pAudioClient->Stop();
			break;
		}

		// Kvȃt[擾
		UINT32 frame_count;
		HRESULT ret = pAudioClient->GetBufferSize( &frame_count );
//		ODS( "t[    : %d\n",frame_count );

		// t[obt@TCYZo
		int buf_size = frame_count * iFrameSize;
//		ODS( "obt@TCY : %dbyte\n",buf_size );


		// o̓obt@̃|C^擾
		LPBYTE dst;
		ret = pRenderClient->GetBuffer( frame_count,&dst );
		if( SUCCEEDED(ret) ) {
			// \[Xobt@̃|C^擾
			LPBYTE src = wav.GetBuffer();

			// ݂̃J[\玟ɕKvȃobt@TCYZƂWAVobt@̃TCY𒴂邩
			if( iAddr+buf_size>wav.GetBufferSize() ) {
				////////////////////////////////////////////////////////////////////////////////////////
				// ꍇ͂܂݂̃J[\Ō܂łRs[AɎc擪[
				////////////////////////////////////////////////////////////////////////////////////////

				// WAVobt@TCY猻݂̃J[\ʒûŌ܂ł̃obt@TCY
				int last_size = wav.GetBufferSize() - iAddr;

				// ݂̃J[\Ō܂ł̃obt@o̓obt@̐擪ɃRs[
				memcpy( &dst[0],&src[iAddr],last_size );

				// KvȃTCY獡Rs[TCŶ擪[obt@TCY
				int begin_size = buf_size - last_size;

				// WAVobt@̐擪[TCYo̓obt@ɒǉRs[
				memcpy( &dst[last_size],&src[0],begin_size );

				// [̃TCỸ݂J[\Ƃ
				iAddr = begin_size;

				ODS( "LOOP OK\n" );
			} else {
				////////////////////////////////////////////////////////////////////////////////////////
				// Ȃꍇ݂͌̃J[\Kvȃobt@Rs[ăJ[\i߂
				////////////////////////////////////////////////////////////////////////////////////////

				// WAVobt@݂̌̃J[\o̓obt@ɎwTCYRs[
				memcpy( &dst[0],&src[iAddr],buf_size );

				// J[\Rs[i߂
				iAddr += buf_size;
			}

			// obt@J
			pRenderClient->ReleaseBuffer( frame_count,0 );
		}

	}

	DEBUG( "XbhI\n" );
	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////
// WASAPȈ
//////////////////////////////////////////////////////////////////////////////////////
BOOL InitWasapi( int latency )
{
	HRESULT ret;

	// }`fBAfoCX񋓎q
	ret = CoCreateInstance( CLSID_MMDeviceEnumerator, NULL, CLSCTX_ALL, IID_IMMDeviceEnumerator, (void**)&pDeviceEnumerator );
	if( FAILED(ret) ) {
		DEBUG( "CLSID_MMDeviceEnumeratorG[\n" );
		return FALSE;
	}

	// ftHg̃foCXI
	ret = pDeviceEnumerator->GetDefaultAudioEndpoint( eRender,eConsole,&pDevice );
	if( FAILED(ret) ) {
		DEBUG( "GetDefaultAudioEndpointG[\n" );
		return FALSE;
	}

	// I[fBINCAg
	ret = pDevice->Activate( IID_IAudioClient, CLSCTX_ALL, NULL, (void**)&pAudioClient );
	if( FAILED(ret) ) {
		DEBUG( "I[fBINCAg擾s\n" );
		return FALSE;
	}

	// tH[}bg̍\z
	WAVEFORMATEXTENSIBLE wf;
	ZeroMemory( &wf,sizeof(wf) );
	wf.Format.cbSize = sizeof(WAVEFORMATEXTENSIBLE);
	wf.Format.wFormatTag			= WAVE_FORMAT_EXTENSIBLE;
	wf.Format.nChannels				= 2;
	wf.Format.nSamplesPerSec		= 44100;
	wf.Format.wBitsPerSample		= 16;
	wf.Format.nBlockAlign			= wf.Format.nChannels * wf.Format.wBitsPerSample / 8;
	wf.Format.nAvgBytesPerSec		= wf.Format.nSamplesPerSec * wf.Format.nBlockAlign;
	wf.Samples.wValidBitsPerSample	= wf.Format.wBitsPerSample;
	wf.dwChannelMask				= SPEAKER_FRONT_LEFT | SPEAKER_FRONT_RIGHT;
	wf.SubFormat					= KSDATAFORMAT_SUBTYPE_PCM;

	// 1TṽTCYۑ(16bitXeIȂ4byte)
	iFrameSize = wf.Format.nBlockAlign;

	// tH[}bg̃T|[g`FbN
	ret = pAudioClient->IsFormatSupported( AUDCLNT_SHAREMODE_EXCLUSIVE,(WAVEFORMATEX*)&wf,NULL );
	if( FAILED(ret) ) {
		DEBUG( "T|[g̃tH[}bg\n" );
		return FALSE;
	}

	// CeVݒ
	REFERENCE_TIME default_device_period = 0;
	REFERENCE_TIME minimum_device_period = 0;

	if( latency!=0 ) {
		default_device_period = (REFERENCE_TIME)latency * 10000LL;		// ftHgfoCXsIhƂăZbg
		DEBUG( "CeVw             : %I64d (%f~b)\n",default_device_period,default_device_period/10000.0 );
	} else {
		ret = pAudioClient->GetDevicePeriod( &default_device_period,&minimum_device_period );
		DEBUG( "ftHgfoCXsIh : %I64d (%f~b)\n",default_device_period,default_device_period/10000.0 );
		DEBUG( "ŏfoCXsIh       : %I64d (%f~b)\n",minimum_device_period,minimum_device_period/10000.0 );
	}

	// 
	UINT32 frame = 0;
	ret = pAudioClient->Initialize( AUDCLNT_SHAREMODE_EXCLUSIVE,
									AUDCLNT_STREAMFLAGS_NOPERSIST | AUDCLNT_STREAMFLAGS_EVENTCALLBACK,
									default_device_period,				// ftHgfoCXsIhlZbg
									default_device_period,				// ftHgfoCXsIhlZbg
									(WAVEFORMATEX*)&wf,
									NULL ); 
	if( FAILED(ret) ) {
		if( ret==AUDCLNT_E_BUFFER_SIZE_NOT_ALIGNED ) {
			DEBUG( "obt@TCYACgG[̂ߏC\n" );

			// C̃t[擾
			ret = pAudioClient->GetBufferSize( &frame );
			DEBUG( "C̃t[         : %d\n",frame );
			default_device_period = (REFERENCE_TIME)( 10000.0 *						// (REFERENCE_TIME(100ns) / ms) *
													  1000 *						// (ms / s) *
													  frame /						// frames /
													  wf.Format.nSamplesPerSec +	// (frames / s)
													  0.5);							// ľܓH
			DEBUG( "C̃CeV         : %I64d (%f~b)\n",default_device_period,default_device_period/10000.0  );

			// xjăI[fBINCAgĐ
			SAFE_RELEASE( pAudioClient );
			ret = pDevice->Activate( IID_IAudioClient, CLSCTX_ALL, NULL, (void**)&pAudioClient );
			if( FAILED(ret) ) {
				DEBUG( "I[fBINCAgĎ擾s\n" );
				return FALSE;
			}

			// Ē
			ret = pAudioClient->Initialize( AUDCLNT_SHAREMODE_EXCLUSIVE,
											AUDCLNT_STREAMFLAGS_NOPERSIST | AUDCLNT_STREAMFLAGS_EVENTCALLBACK,
											default_device_period,
											default_device_period,
											(WAVEFORMATEX*)&wf,
											NULL );
		}

		if( FAILED(ret) ) {
			DEBUG( "s : 0x%08X\n",ret );
			switch( ret )
			{
			case AUDCLNT_E_NOT_INITIALIZED:					DEBUG( "AUDCLNT_E_NOT_INITIALIZED\n" );					break;
			case AUDCLNT_E_ALREADY_INITIALIZED:				DEBUG( "AUDCLNT_E_ALREADY_INITIALIZED\n" );				break;
			case AUDCLNT_E_WRONG_ENDPOINT_TYPE:				DEBUG( "AUDCLNT_E_WRONG_ENDPOINT_TYPE\n" );				break;
			case AUDCLNT_E_DEVICE_INVALIDATED:				DEBUG( "AUDCLNT_E_DEVICE_INVALIDATED\n" );				break;
			case AUDCLNT_E_NOT_STOPPED:						DEBUG( "AUDCLNT_E_NOT_STOPPED\n" );						break;
			case AUDCLNT_E_BUFFER_TOO_LARGE:				DEBUG( "AUDCLNT_E_BUFFER_TOO_LARGE\n" );				break;
			case AUDCLNT_E_OUT_OF_ORDER:					DEBUG( "AUDCLNT_E_OUT_OF_ORDER\n" );					break;
			case AUDCLNT_E_UNSUPPORTED_FORMAT:				DEBUG( "AUDCLNT_E_UNSUPPORTED_FORMAT\n" );				break;
			case AUDCLNT_E_INVALID_SIZE:					DEBUG( "AUDCLNT_E_INVALID_SIZE\n" );					break;
			case AUDCLNT_E_DEVICE_IN_USE:					DEBUG( "AUDCLNT_E_DEVICE_IN_USE\n" );					break;
			case AUDCLNT_E_BUFFER_OPERATION_PENDING:		DEBUG( "AUDCLNT_E_BUFFER_OPERATION_PENDING\n" );		break;
			case AUDCLNT_E_THREAD_NOT_REGISTERED:			DEBUG( "AUDCLNT_E_THREAD_NOT_REGISTERED\n" );			break;
//			case AUDCLNT_E_NO_SINGLE_PROCESS:				DEBUG( "AUDCLNT_E_NO_SINGLE_PROCESS\n" );				break;	// VC2010ł͖`H
			case AUDCLNT_E_EXCLUSIVE_MODE_NOT_ALLOWED:		DEBUG( "AUDCLNT_E_EXCLUSIVE_MODE_NOT_ALLOWED\n" );		break;
			case AUDCLNT_E_ENDPOINT_CREATE_FAILED:			DEBUG( "AUDCLNT_E_ENDPOINT_CREATE_FAILED\n" );			break;
			case AUDCLNT_E_SERVICE_NOT_RUNNING:				DEBUG( "AUDCLNT_E_SERVICE_NOT_RUNNING\n" );				break;
			case AUDCLNT_E_EVENTHANDLE_NOT_EXPECTED:		DEBUG( "AUDCLNT_E_EVENTHANDLE_NOT_EXPECTED\n" );		break;
			case AUDCLNT_E_EXCLUSIVE_MODE_ONLY:				DEBUG( "AUDCLNT_E_EXCLUSIVE_MODE_ONLY\n" );				break;
			case AUDCLNT_E_BUFDURATION_PERIOD_NOT_EQUAL:	DEBUG( "AUDCLNT_E_BUFDURATION_PERIOD_NOT_EQUAL\n" );	break;
			case AUDCLNT_E_EVENTHANDLE_NOT_SET:				DEBUG( "AUDCLNT_E_EVENTHANDLE_NOT_SET\n" );				break;
			case AUDCLNT_E_INCORRECT_BUFFER_SIZE:			DEBUG( "AUDCLNT_E_INCORRECT_BUFFER_SIZE\n" );			break;
			case AUDCLNT_E_BUFFER_SIZE_ERROR:				DEBUG( "AUDCLNT_E_BUFFER_SIZE_ERROR\n" );				break;
			case AUDCLNT_E_CPUUSAGE_EXCEEDED:				DEBUG( "AUDCLNT_E_CPUUSAGE_EXCEEDED\n" );				break;
			default:										DEBUG( "UNKNOWN\n" );									break;
			}
			return FALSE;
		}
	}

	// Cxg
	hEvent = CreateEvent( NULL,FALSE,FALSE,NULL );
	if( !hEvent ) {
		DEBUG( "CxgIuWFNg쐬s\n" );
		return FALSE;
	}

	// Cxg̃Zbg
	ret = pAudioClient->SetEventHandle( hEvent );
	if( FAILED(ret) ) {
		DEBUG( "CxgIuWFNgݒ莸s\n" );
		return FALSE;
	}

	// _[̎擾
	ret = pAudioClient->GetService( IID_IAudioRenderClient,(void**)&pRenderClient );
	if( FAILED(ret) ) {
		DEBUG( "_[擾G[\n" );
		return FALSE;
	}

	// WASAPI擾
	ret = pAudioClient->GetBufferSize( &frame );
	DEBUG( "ݒ肳ꂽt[       : %d\n",frame );

	UINT32 size = frame * iFrameSize;
	DEBUG( "ݒ肳ꂽobt@TCY   : %dbyte\n",size );
	DEBUG( "1Tv̎            : %fb\n",(float)size/wf.Format.nSamplesPerSec );

	// [NAăCxgZbg
	LPBYTE pData;
	ret = pRenderClient->GetBuffer( frame,&pData );
	if( SUCCEEDED(ret) ) {
		ZeroMemory( pData,size );
		pRenderClient->ReleaseBuffer( frame,0 );
	}

	// Xbh[vtO𗧂Ă
	bThreadLoop = TRUE;

	// ĐXbhN
	DWORD dwThread;
	hThread = CreateThread( NULL,0,PlayThread,NULL,0,&dwThread );
	if( !hThread ) {
		// s
		return FALSE;
	}

	// ĐJn
	pAudioClient->Start();

	DEBUG( "WASAPI\n" );
	return TRUE;
}


//////////////////////////////////////////////////////////////////////////////////////
// WASAPȈI
//////////////////////////////////////////////////////////////////////////////////////
void ExitWasapi()
{
	// Xbh[vtO𗎂Ƃ
	bThreadLoop = FALSE;

	// XbhI
	if( hThread ) {
		// XbhSɏI܂őҋ@
		WaitForSingleObject( hThread,INFINITE );
		CloseHandle( hThread );
		hThread = NULL;
	}

	// CxgJ
	if( hEvent ) {
		CloseHandle( hEvent );
		hEvent = NULL;
	}

	// C^[tF[XJ
	SAFE_RELEASE( pRenderClient );
	SAFE_RELEASE( pAudioClient );
	SAFE_RELEASE( pDevice );
	SAFE_RELEASE( pDeviceEnumerator );

	DEBUG( "WASAPII\n" );
}


//////////////////////////////////////////////////////////////////////////////////////
// C[`
//////////////////////////////////////////////////////////////////////////////////////
int WINAPI WinMain( HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpszCmdParam,int nCmdShow )
{
	// fobO`
	INITDEBUG( "DEBUG.TXT" );
	CLEARDEBUG;

	// EBhE
	if( !win.Create(hInstance,L"TestWasapi") ) {
		DEBUG( "EBhEG[\n" );
		return -1;
	}

	// {̖͂
	ImmAssociateContext( win.hWnd, NULL );

	// WAV[h
	if( !wav.Load("loop.wav") ) {
		win.Delete();
		return -1;
	}

	// COM̏
	CoInitialize( NULL );

	// WASAPI
	if( !InitWasapi(0) ) {			// 0ȂftHgfoCXsIhgp
		// G[ȂI
		MessageBoxA( win.hWnd,"WASAPIs","G[",MB_OK|MB_ICONHAND );
		ExitWasapi();
		CoUninitialize();
		win.Delete();
		return -1;
	}

	// EBhE[v
	while(1) {
		MSG msg;
		int ret = GetMessage( &msg,NULL,0,0 );		// bZ[Wo^܂ŃubN
		if( ret==0 || ret==-1 ) {
			// IR[hȂ甲
			break;
		}
		// bZ[W
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}

	// WASAPII
	ExitWasapi();

	// COM̏I
	CoUninitialize();

	// EBhE폜
	win.Delete();

	return 0;
}
